#[doc = "Register `USBMODE_IMO_GAIN_TRIM` reader"]
pub struct R(crate::R<USBMODE_IMO_GAIN_TRIM_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<USBMODE_IMO_GAIN_TRIM_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<USBMODE_IMO_GAIN_TRIM_SPEC>> for R {
    fn from(reader: crate::R<USBMODE_IMO_GAIN_TRIM_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `USBMODE_IMO_GAIN_TRIM` writer"]
pub struct W(crate::W<USBMODE_IMO_GAIN_TRIM_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<USBMODE_IMO_GAIN_TRIM_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<USBMODE_IMO_GAIN_TRIM_SPEC>> for W {
    fn from(writer: crate::W<USBMODE_IMO_GAIN_TRIM_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `CLK_IMO_TRIM4` reader - Trim data"]
pub struct CLK_IMO_TRIM4_R(crate::FieldReader<u8, u8>);
impl CLK_IMO_TRIM4_R {
    pub(crate) fn new(bits: u8) -> Self {
        CLK_IMO_TRIM4_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for CLK_IMO_TRIM4_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `CLK_IMO_TRIM4` writer - Trim data"]
pub struct CLK_IMO_TRIM4_W<'a> {
    w: &'a mut W,
}
impl<'a> CLK_IMO_TRIM4_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x1f) | (value as u8 & 0x1f);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:4 - Trim data"]
    #[inline(always)]
    pub fn clk_imo_trim4(&self) -> CLK_IMO_TRIM4_R {
        CLK_IMO_TRIM4_R::new((self.bits & 0x1f) as u8)
    }
}
impl W {
    #[doc = "Bits 0:4 - Trim data"]
    #[inline(always)]
    pub fn clk_imo_trim4(&mut self) -> CLK_IMO_TRIM4_W {
        CLK_IMO_TRIM4_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "PSoC4AL CU IMO Gain Trim\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [usbmode_imo_gain_trim](index.html) module"]
pub struct USBMODE_IMO_GAIN_TRIM_SPEC;
impl crate::RegisterSpec for USBMODE_IMO_GAIN_TRIM_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [usbmode_imo_gain_trim::R](R) reader structure"]
impl crate::Readable for USBMODE_IMO_GAIN_TRIM_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [usbmode_imo_gain_trim::W](W) writer structure"]
impl crate::Writable for USBMODE_IMO_GAIN_TRIM_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets USBMODE_IMO_GAIN_TRIM to value 0"]
impl crate::Resettable for USBMODE_IMO_GAIN_TRIM_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
